package edu.worcester.cs;

/*
    Copyright (C) 2018 Karl R. Wurst

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Represents a customer with customer number, first and last name.
 * 
 * @author kwurst
 * @version Fall 2018
 */
public class Customer {

	private static int nextNumber = 1;
	private int number;
	private String firstName;
	private String lastName;
	
	/**
	 * Represents a customer with customer number (autogenerated), first and last name.
	 * @param firstName
	 * @param lastName
	 */
	public Customer(String firstName, String lastName) {
		this.number = nextNumber++;
		this.firstName = firstName;
		this.lastName = lastName;
	}

	/**
	 * Returns the first name
	 * @return the first name
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * Returns the last name
	 * @return the last name
	 */
	public String getLastName() {
		return lastName;
	}
	
	/**
	 * Sets the first name
	 * @param firstName
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	/**
	 * Sets the last name
	 * @param lastName
	 */
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	/**
	 * Returns the customer number
	 * @return the customer number
	 */
	public int getNumber() {
		return number;
	}

	@Override
	public String toString() {
		return "Customer [number=" + number + ", name=" + firstName + " " + lastName + "]";
	}

	/** 
	 * Customers are equal *only* if their customer numbers are equal
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Customer other = (Customer) obj;
		if (number != other.number)
			return false;
		return true;
	}	

}